--
--
-- Specializations Feux for MF 3080
-- @Autor Fendt413
-- @Date 25/12/09
--
--


Feux = {};

function Feux.prerequisitesPresent(specializations)
    return true
end;

function Feux:load(xmlFile)
	self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;
	self.brakelightsActive = false;
end;

function Feux:delete()
end;

function Feux:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Feux:keyEvent(unicode, sym, modifier, isDown)
end;

function Feux:update(dt)
	if self.isEntered ~= nil then
		if self.brakelightsActive then
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive);
			end;
		else
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive, false);
			end;
		end;
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
		if (self.movingDirection*self.lastSpeed*-inputAxisY) < -0.001 then		
			self.brakelightsActive = true;
		else
			self.brakelightsActive = false;
		end;
    end;
end;

function Feux:draw()
end;
