--
--
-- Specializations Powershift for MF 3080
-- @Autor Fendt413
-- @Date 25/12/09
--
--


Powershift = {};

function Powershift.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Powershift:load(xmlFile)
	local rotationNodePartManetteG = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartManetteG#index"));
    if rotationNodePartManetteG ~= nil then
        self.rotationPartManetteG = {};
        self.rotationPartManetteG.node = rotationNodePartManetteG;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartManetteG#minRot"));
        self.rotationPartManetteG.minRot = {};
        self.rotationPartManetteG.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartManetteG.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartManetteG.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartManetteG#maxRot"));
        self.rotationPartManetteG.maxRot = {};
        self.rotationPartManetteG.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartManetteG.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartManetteG.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartManetteG.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartManetteG#rotTime"), 2)*1000;
        self.rotationPartManetteG.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartManetteG#touchRotLimit"), 10));
    end;  
	local rotationNodePartManetteD = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartManetteD#index"));
    if rotationNodePartManetteD ~= nil then
        self.rotationPartManetteD = {};
        self.rotationPartManetteD.node = rotationNodePartManetteD;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartManetteD#minRot"));
        self.rotationPartManetteD.minRot = {};
        self.rotationPartManetteD.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartManetteD.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartManetteD.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartManetteD#maxRot"));
        self.rotationPartManetteD.maxRot = {};
        self.rotationPartManetteD.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartManetteD.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartManetteD.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartManetteD.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartManetteD#rotTime"), 2)*1000;
        self.rotationPartManetteD.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartManetteD#touchRotLimit"), 10));
    end;  


	self.controlpath = Utils.getFilename("HUD/PowershiftHud.png", self.baseDirectory);
    self.PowershiftWidth = 0.130;
    self.PowershiftHeight = 0.100;
	self.PowershiftPoxX = 0.70;
    self.PowershiftPoxY = 0.01;
    self.PowershiftOverlay = Overlay:new("PowershiftControl", self.controlpath, self.PowershiftPoxX, self.PowershiftPoxY, self.PowershiftWidth, self.PowershiftHeight);
	self.gear0 = true;
	self.groupA = false;
	self.groupB = false;
	self.groupR = false;
	self.groupN = true;	
end;

function Powershift:delete()

if self.RpmBaseOverlay then
        self.RpmBaseOverlay:delete();
    end;

end;

function Powershift:mouseEvent(posX, posY, isDown, isUp, button)

end;

function Powershift:keyEvent(unicode, sym, modifier, isDown)
	
	if not self.isAutomatic then
		if isDown and sym == Input.KEY_pageup then
			if self.gearR2 == true then
				self.gearR1 = true;
				self.gearR2 = false;
			elseif self.gearR1 == true then
				self.gear0 = true;
				self.gearR1 = false;
				self.groupA = false;
				self.groupB = false;
				self.groupR = false;
				self.groupN = true;
			elseif self.gear0 == true then
				self.reverse = false;
				self.gear1 = true;
				self.gear0 = false;
				self.groupN = false;
				self.groupA = true;
				self.groupB = false;
				self.groupR = false;	
			elseif self.gear1 == true then
				self.gear2 = true;
				self.gear1 = false;	
			elseif self.gear2 == true then
				self.gear3 = true;
				self.gear2 = false;
			elseif self.gear3 == true then
				self.gear4 = true;
				self.gear3 = false;
			elseif self.gear4 == true then
				self.gear4 = false;
				self.gear01 = true;
				self.groupA = false;
				self.groupB = true;
				self.groupR = false;
				self.groupN = false;
			elseif self.gear01 == true then
				self.gear02 = true;
				self.gear01 = false;
			elseif self.gear02 == true then
				self.gear03 = true;
				self.gear02 = false;
			elseif self.gear03 == true then
				self.gear04 = true;
				self.gear03 = false;
			end;
		end;			
		if isDown and sym == Input.KEY_pagedown then
			if self.gear04 == true then
				self.gear03 = true;
				self.gear04 = false;
			elseif self.gear03 == true then
				self.gear02 = true;
				self.gear03 = false;
			elseif self.gear02 == true then
				self.gear01 = true;
				self.gear02 = false;
			elseif self.gear01 == true then
				  self.gear4 = true;
				  self.gear01 = false;
				  self.groupB = false;
				  self.groupA = true;
				  self.groupN = false;
				  self.groupR = false;
			elseif self.gear4 == true then
				self.gear3 = true;
				self.gear4 = false;								
			elseif self.gear3 == true then
				self.gear2 = true;
				self.gear3 = false;
			elseif self.gear2 == true then
				self.gear1 = true;
				self.gear2 = false;
			elseif self.gear1 == true then
				self.gear0 = true;
				self.gear1 = false;
				self.groupA = false;
				self.groupN = true;
			elseif self.gear0 == true then
				self.gearR1 = true;
				self.reverse = true;
				self.gear0 = false;
				self.groupR = true;
				self.groupA = false;
				self.groupB = false;
				self.groupN = false;
			elseif self.gearR1 == true then
				self.gearR2 = true;
				self.reverse = true;
				self.gearR1 = false;
			end;
		end;
		if isDown and sym == Input.KEY_home then			
			if self.groupA == true then		
				self.groupA = false;
				self.groupB = true;
				self.groupR = false;
				self.groupN = false;
		
			
				self.gear2 = false;
				self.gearR1 = false;
				self.gear0 = false;
				self.gear1 = false;
				self.gearR2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = true;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = false;
			elseif self.groupR == true then
				self.groupA = false;
				self.groupB = false;
				self.groupR = false;
				self.groupN = true;
				
				self.gear2 = false;
				self.gearR1 = false;
				self.gear0 = true;
				self.gear1 = false;
				self.gearR2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = false;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = false;			
			elseif self.groupN == true then
				self.groupA = true;
				self.groupB = false;
				self.groupR = false;
				self.groupN = false;
				
				self.gear2 = false;
				self.gearR1 = false;
				self.gear0 = false;
				self.gear1 = true;
				self.gearR2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = false;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = false;
			elseif self.groupB == true then
				self.groupA = false;
				self.groupB = true;
				self.groupR = false;
				self.groupN = false;
				
			end;
		end;	
		if isDown and sym == Input.KEY_end then	
			if self.groupB == true then
				self.groupA = true;
				self.groupB = false;
				self.groupR = false;
				self.groupN = false;
				
				self.gearR2 = false;
				self.gearR1 = false;
				self.gear0 = false;
				self.gear1 = true;
				self.gear2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = false;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = false;					
			elseif self.groupA == true then			
				self.groupA = false;
				self.groupB = false;
				self.groupR = false;
				self.groupN = true;
				
				self.gearR2 = false;
				self.gearR1 = false;
				self.gear0 = true;
				self.gear1 = false;
				self.gear2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = false;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = false;	
			elseif self.groupN == true then			
				self.groupA = false;
				self.groupB = false;
				self.groupR = true;
				self.groupN = false;
				
				self.gearR2 = false;
				self.gearR1 = true;
				self.gear0 = false;
				self.gear1 = false;
				self.gear2 = false;
				self.gear3 = false;
				self.gear4 = false;
				self.gear01 = false;
				self.gear02 = false;
				self.gear03 = false;
				self.gear04 = false;
				self.reverse = true;
			elseif self.groupR == true then			
				self.groupA = false;
				self.groupB = false;
				self.groupR = true;
				self.groupN = false;
			end;		
		end;
	end;

end;

function Powershift:update(dt)
	if self.isMotorStarted then
		local fuelUsed = self.motor.lastMotorRpm/1000*self.fuelUsage;
		self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);
        g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
        g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
	end;	
   	if self.isMotorStarted and not self.isHired  then
	    local acceleration = 0;
		local brakeTorque;
        if g_currentMission.allowSteerableMoving and not self.playMotorSound then
			if self.reverse then
				if self.gearR1 then
				    if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = -0.1;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.maxRot[1]
						y = self.rotationPartManetteG.minRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
				elseif self.gearR2 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = -0.2;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.maxRot[1]
						y = self.rotationPartManetteG.maxRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;

				end;
			else
				if self.gear0 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = 0
						y = (self.rotationPartManetteG.maxRot[2] /2)
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
				elseif self.gear1 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.1;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.minRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.minRot[1]
						y = self.rotationPartManetteD.minRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear2 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.15;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.minRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.maxRot[1]
						y = self.rotationPartManetteD.minRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear3 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.2;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.minRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.minRot[1]
						y = self.rotationPartManetteD.maxRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear4 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.3;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.minRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.maxRot[1]
						y = self.rotationPartManetteD.maxRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear01 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.35;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.maxRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.minRot[1]
						y = self.rotationPartManetteD.minRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear02 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.45;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.maxRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.maxRot[1]
						y = self.rotationPartManetteD.minRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear03 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 0.75;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.maxRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.minRot[1]
						y = self.rotationPartManetteD.maxRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
				elseif self.gear04 then
					if Input.isKeyPressed(Input.KEY_w) or self.motor.speedLevel ~= 0 then
						acceleration = 1;
					end;
					if self.rotationPartManetteG ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteG.node);
						x = self.rotationPartManetteG.minRot[1]
						y = self.rotationPartManetteG.maxRot[2]
						setRotation(self.rotationPartManetteG.node, x, y ,z);
					end;
					if self.rotationPartManetteD ~= nil then
						local x, y, z = getRotation(self.rotationPartManetteD.node);
						x = self.rotationPartManetteD.maxRot[1]
						y = self.rotationPartManetteD.maxRot[2]
						setRotation(self.rotationPartManetteD.node, x, y ,z);
					end;
			    end;
			end;			
			if Input.isKeyPressed(Input.KEY_w) then
				self.motor:setSpeedLevel(0, true)
			end;
		end;       
		if self.isEntered then
			if self.fuelFillLevel < 50 then
			self.tankwarn = self.tankwarn - dt;
			if self.tankwarn <= 0 then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.tankwarn = 30000;
			end;
		else
			self.tankwarn = 30000;			
		end;
	end;
		
	if self.fuelFillLevel == 0 then
        acceleration = 0;
    end;

	if self.firstTimeRun then
        WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeed, acceleration, false, self.requiredDriveMode)
    end;
	
	local ratio = 0;
	local rpmRange = 0;
	if self.gearR2 then
		ratio = 6.5;
		rpmRange = 140;
	elseif self.gearR1 then
		ratio = 14;
		rpmRange = 130;
	elseif self.gear0 then
		ratio = 0;
	elseif self.gear1 then
		ratio = 28;
		rpmRange = 120;
	elseif self.gear2 then
		ratio = 24;
		rpmRange = 110;
	elseif self.gear3 then
		ratio = 20;
		rpmRange = 100;
	elseif self.gear4 then
		ratio = 9;
		rpmRange = 70;
	elseif self.gear01 then
		ratio = 6.5;
		rpmRange = 50;
	elseif self.gear02 then
		ratio = 5.4;
		rpmRange = 40;
	elseif self.gear03 then
		ratio = 3.0;
		rpmRange = 15;
	elseif self.gear04 then
		ratio = 2.27;
		rpmRange = 1;
	end;
		
	self.motor.backwardGearRatio = ratio;
	self.motor.forwardGearRatios = {ratio/2,ratio/1.5,ratio};
	self.motor.rpmFadeOutRange = rpmRange;				
		

	if self.isHired then	
		local acceleration = 0;
		if g_currentMission.allowSteerableMoving and not self.playMotorSound then
			acceleration = -InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
			if InputBinding.isAxisZero(acceleration) then
				acceleration = -InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
			end;
			if math.abs(acceleration) > 0.8 then
				self.motor:setSpeedLevel(0, true)
			end;
			if self.motor.speedLevel ~= 0 then
				acceleration = 1.0;
			end;		 
		end;		
	end;
	end;

end;
	


function Powershift:draw()	
	self.PowershiftOverlay:render();
	if self.groupA then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.045, self.PowershiftPoxY+0.08, 0.018, "A");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.045, self.PowershiftPoxY+0.08, 0.018, "A");
	end;
	if self.gearR1 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.045, self.PowershiftPoxY+0.035, 0.018, "R1");
	else 
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.045, self.PowershiftPoxY+0.035, 0.018, "R1");
	end;
	if self.gear0 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.064, self.PowershiftPoxY+0.035, 0.018, "N");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.064, self.PowershiftPoxY+0.035, 0.018, "N");
	end;
	if self.gear1 or self.gear01 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.005, self.PowershiftPoxY+0.08, 0.018, "1");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.005, self.PowershiftPoxY+0.08, 0.018, "1");
	end;
	if self.gear2 or self.gear02 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.005, self.PowershiftPoxY+0.035, 0.018, "2");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.005, self.PowershiftPoxY+0.035, 0.018, "2");
	end;
	if self.gear3 or self.gear03 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.0293, self.PowershiftPoxY+0.08, 0.018, "3");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.0293, self.PowershiftPoxY+0.08, 0.018, "3");
	end;
	if self.gear4 or self.gear04 then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.0293, self.PowershiftPoxY+0.035, 0.018, "4");
	else
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.0293, self.PowershiftPoxY+0.035, 0.018, "4");
	end;
	if self.gearR2 == true then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.089, self.PowershiftPoxY+0.035, 0.018, "R2");
	else 
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.089, self.PowershiftPoxY+0.035, 0.018, "R2");
	end;
	if self.groupB then
		setTextColor(0,1,0,1);
		renderText(self.PowershiftPoxX+0.089, self.PowershiftPoxY+0.08, 0.018, "B");
	else 
		setTextColor(1,1,1,1);
		renderText(self.PowershiftPoxX+0.089, self.PowershiftPoxY+0.08, 0.018, "B");
	end;
end;

function Powershift:onEnter()	
end;

function Powershift:onLeave()	
	if not self.isAITractorActivated then			
		self.gear0 = true;
		self.neutral = true;
		self.groupN = true;
		self.groupA = false;
		self.groupB = false;
		self.groupR = false;
		self.gearR2 = false;
		self.gearR1 = false;
		self.gear1 = false;
		self.gear2 = false;
		self.gear3 = false;
		self.gear4 = false;

		self.gear01 = false;
		self.gear02 = false;
		self.gear03 = false;
		self.gear04 = false;
	end;
end;

function Powershift:drawGrainLevel(level, capacity, warnPercent)
end;
