--
--
-- Specializations RAR for MF 3080
-- @Autor Fendt413
-- @Date 25/12/09
--
--

RAR = {};

function RAR.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function RAR:load(xmlFile)

	local rotationNodePartRAR = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR#index"));
    if rotationNodePartRAR ~= nil then
        self.rotationPartRAR = {};
        self.rotationPartRAR.node = rotationNodePartRAR;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR#minRot"));
        self.rotationPartRAR.minRot = {};
        self.rotationPartRAR.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR#maxRot"));
        self.rotationPartRAR.maxRot = {};
        self.rotationPartRAR.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR#rotTime"), 2)*1000;
        self.rotationPartRAR.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR#touchRotLimit"), 10));
    end;  
	
	local rotationNodePartRAR2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR2#index"));
    if rotationNodePartRAR2 ~= nil then
        self.rotationPartRAR2 = {};
        self.rotationPartRAR2.node = rotationNodePartRAR2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR2#minRot"));
        self.rotationPartRAR2.minRot = {};
        self.rotationPartRAR2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR2#maxRot"));
        self.rotationPartRAR2.maxRot = {};
        self.rotationPartRAR2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR2#rotTime"), 2)*1000;
        self.rotationPartRAR2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR2#touchRotLimit"), 10));
    end; 
	local rotationNodePartRAR3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR3#index"));
    if rotationNodePartRAR3 ~= nil then
        self.rotationPartRAR3 = {};
        self.rotationPartRAR3.node = rotationNodePartRAR3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR3#minRot"));
        self.rotationPartRAR3.minRot = {};
        self.rotationPartRAR3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR3#maxRot"));
        self.rotationPartRAR3.maxRot = {};
        self.rotationPartRAR3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR3#rotTime"), 2)*1000;
        self.rotationPartRAR3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR3#touchRotLimit"), 10));
    end;  
	local rotationNodePartRAR4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR4#index"));
    if rotationNodePartRAR4 ~= nil then
        self.rotationPartRAR4 = {};
        self.rotationPartRAR4.node = rotationNodePartRAR4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR4#minRot"));
        self.rotationPartRAR4.minRot = {};
        self.rotationPartRAR4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR4#maxRot"));
        self.rotationPartRAR4.maxRot = {};
        self.rotationPartRAR4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR4#rotTime"), 2)*1000;
        self.rotationPartRAR4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR4#touchRotLimit"), 10));
    end;  
	local rotationNodePartRAR5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR5#index"));
    if rotationNodePartRAR5 ~= nil then
        self.rotationPartRAR5 = {};
        self.rotationPartRAR5.node = rotationNodePartRAR5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR5#minRot"));
        self.rotationPartRAR5.minRot = {};
        self.rotationPartRAR5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR5#maxRot"));
        self.rotationPartRAR5.maxRot = {};
        self.rotationPartRAR5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR5#rotTime"), 2)*1000;
        self.rotationPartRAR5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR5#touchRotLimit"), 10));
    end;  
	local rotationNodePartRAR6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRAR6#index"));
    if rotationNodePartRAR6 ~= nil then
        self.rotationPartRAR6 = {};
        self.rotationPartRAR6.node = rotationNodePartRAR6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR6#minRot"));
        self.rotationPartRAR6.minRot = {};
        self.rotationPartRAR6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRAR6#maxRot"));
        self.rotationPartRAR6.maxRot = {};
        self.rotationPartRAR6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRAR6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRAR6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRAR6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR6#rotTime"), 2)*1000;
        self.rotationPartRAR6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRAR6#touchRotLimit"), 10));
    end;  

	self.Levier = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Levier#index")); 
	self.lever = false;
	self.abaisser = false;
end;
function RAR:delete()
end;


function RAR:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RAR:keyEvent(unicode, sym, modifier, isDown)
	if sym == Input.KEY_KP_1 then
		self.rotationMaxRAR = isDown;
		self.rotationMaxRAR2 = isDown;
		self.rotationMaxRAR3 = isDown;
		self.rotationMaxRAR4 = isDown;
		self.rotationMaxRAR5 = isDown;
		self.rotationMaxRAR6 = isDown;
		self.lever = isDown;
		self.abaisser = false;
	end;
	if sym == Input.KEY_KP_0 then
		self.rotationMinRAR = isDown;
		self.rotationMinRAR2 = isDown;
		self.rotationMinRAR3 = isDown;
		self.rotationMinRAR4 = isDown;
		self.rotationMinRAR5 = isDown;
		self.rotationMinRAR6 = isDown;
		self.abaisser = isDown;
		self.lever = false;
	end;	
end;
function RAR:update(dt)
	local doRotate = self.rotationMaxRAR or self.rotationMinRAR
	if self.rotationPartRAR ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR.maxRot, self.rotationPartRAR.minRot, 3, self.rotationPartRAR.rotTime, dt, not self.rotationMaxRAR);
        setRotation(self.rotationPartRAR.node, unpack(newRot));
    end;
	local doRotate = self.rotationMaxRAR2 or self.rotationMinRAR2
	if self.rotationPartRAR2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR2.maxRot, self.rotationPartRAR2.minRot, 3, self.rotationPartRAR2.rotTime, dt, not self.rotationMaxRAR2);
        setRotation(self.rotationPartRAR2.node, unpack(newRot));
    end;
	local doRotate = self.rotationMaxRAR3 or self.rotationMinRAR3
	if self.rotationPartRAR3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR3.maxRot, self.rotationPartRAR3.minRot, 3, self.rotationPartRAR3.rotTime, dt, not self.rotationMaxRAR3);
        setRotation(self.rotationPartRAR3.node, unpack(newRot));
    end;
	local doRotate = self.rotationMaxRAR4 or self.rotationMinRAR4
	if self.rotationPartRAR4 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR4.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR4.maxRot, self.rotationPartRAR4.minRot, 3, self.rotationPartRAR4.rotTime, dt, not self.rotationMaxRAR4);
        setRotation(self.rotationPartRAR4.node, unpack(newRot));
    end;
	local doRotate = self.rotationMaxRAR5 or self.rotationMinRAR5
	if self.rotationPartRAR5 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR5.maxRot, self.rotationPartRAR5.minRot, 3, self.rotationPartRAR5.rotTime, dt, not self.rotationMaxRAR5);
        setRotation(self.rotationPartRAR5.node, unpack(newRot));
    end;
	local doRotate = self.rotationMaxRAR6 or self.rotationMinRAR6
	if self.rotationPartRAR6 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartRAR6.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRAR6.maxRot, self.rotationPartRAR6.minRot, 3, self.rotationPartRAR6.rotTime, dt, not self.rotationMaxRAR6);
        setRotation(self.rotationPartRAR6.node, unpack(newRot));
    end;
	if self.abaisser then 
		setRotation(self.Levier, 0, Utils.degToRad(25), 0);
	else
		setRotation(self.Levier, 0, Utils.degToRad(0), 0);	
	end;
	if self.lever then
		setRotation(self.Levier, 0, Utils.degToRad(-25), 0);
	else
		setRotation(self.Levier, 0, Utils.degToRad(0), 0);	
	end;
end;

function RAR:draw()
end;
function RAR:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;